> ## Documentation Index
> Fetch the complete documentation index at: https://docs.sonderplan.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Calendar Subscription

> 
<Note>`WRITE` access to the `ADMIN` module is required to access this endpoint</Note>



## OpenAPI

````yaml /api-reference/openapi-mintlify.yaml put /v2/calendar-subscription/import
openapi: 3.0.0
info:
  title: Sonderplan API
  description: >
    ## Overview

    You can use our REST API to securely access and modify the data within your
    Sonderplan account. This includes all the information within your bookings,
    projects and invoices that you can use to import / export data or create
    integrations with other systems and software that you use


    ### General Notes


    #### Specifying Fields

    The Sonderplan REST API allows you to specify a comma delimited string of
    exactly which fields are returned, using the `fields` parameter. Using this
    parameter has several advantages including:


    1. In future API versions we may change which fields are presented by
    default, so explicitly specifying the fields required overrides the defaults
    and ensure the fields are served

    2. Limiting fields reduces the processing we need to do and allows us to
    send you the data faster

    3. Some search filters only work if the field you are searching is added to
    the `fields` parameter.


    Example:


    ```

    fields=id,name,start,duration_min

    ```


    ### Applying Filters


    The Query Parameters section in each endpoint shows you special options that
    can be added to your request to customise the response we send you.


    Most endpoints offer the following query params:


    | Query Parameter |
    Description                                                    |

    |-----------------|----------------------------------------------------------------|

    | `fields`        | Only send the specified
    fields                                 |

    | `id`            | Specify one or more ids (comma seperated) of records to
    return |

    | `limit`         | The maximum number of records to
    return                        |

    | `page`          | The page number of records to
    return                           |

    | `order_asc` | Specify which field should be used to sort records
    `ascending` |

    | `order_desc` | Specify which field should be used to sort records
    `descending` |


    In addition to the standard `id` param, you can also specify most other
    fields as a query parameter, useful for performing searching and filtering
    of records.


    For example, you can specify `repeat_master_id=<repeat_booking_id>` to
    return all repeat children of that booking.


    #### Other Query Params


    Refer to the specific API endpoint documentation to see which other query
    params can be used.


    For example, some endpoints allow specifying `updated_after=<UNIX
    TIMESTAMP>` which will only send added, edited and even deleted records that
    were modified after the unix timestamp.


    #### Applying multiple filters


    By default, multiple filters are chained together using **OR** (either
    filter can be true and it will be included). You can change this behaviour
    by specifying `filter_operator=AND`, so each filter must be true to be
    included.


    #### Filtering by Custom Field Values


    For modules that include custom fields, you can search by the value of a
    custom field by adding the `custom_field_<field id>` to the URL query
    parameters. You **must** also specify the custom field in the `fields`
    parameter.


    ```

    GET
    https://api.sonderplan.com/v2/booking?fields=id,name,custom_field_238938&custom_field_238938=Offline

    ```


    This will return custom fields that contain the word 'Offline'.
  contact:
    email: info@sonderplan.com
  version: '2.0'
servers:
  - url: https://api.sonderplan.com
    description: Production Server
security: []
tags:
  - name: Booking
    description: Booking related operations
  - name: Project
    description: Project related operations
  - name: Resource
    description: Resource related operations
  - name: Contact
    description: Contact related operations
  - name: Quote
    description: Quote related operations
  - name: Invoice
    description: Invoice related operations
  - name: Invoice Template
    description: Invoice template related operations
  - name: Billable Item
    description: Billable item related operations
  - name: Rate Scheme
    description: Rate scheme related operations
  - name: Tax
    description: Tax related operations
  - name: Workspace
    description: Workspace (formerly Schedule) related operations
  - name: User
    description: User related operations
  - name: Group
    description: Group related operations
  - name: Status
    description: Status related operations
  - name: Custom Field
    description: Custom field related operations
  - name: Calendar Subscription
    description: Calendar Subscription Import related operations
  - name: Time Entry
    description: Time Entry related operations
  - name: Time Activity
    description: Time Activity related operations
paths:
  /v2/calendar-subscription/import:
    put:
      tags:
        - Calendar Subscription
      summary: Update Calendar Subscription
      description: >-

        <Note>`WRITE` access to the `ADMIN` module is required to access this
        endpoint</Note>
      operationId: 781daff770e2d161e8d6b05db3ccba2b
      parameters:
        - name: id
          in: query
          description: The ID of the calendar subscription you wish to update
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              allOf:
                - properties:
                    calendar_url:
                      readOnly: true
                  type: object
                - $ref: '#/components/schemas/CalendarSubscriptionImportModel'
      responses:
        '200':
          description: Successful Operation
          content:
            application/json:
              schema:
                properties:
                  success:
                    properties:
                      id:
                        description: The ID of the newly created object
                        type: integer
                        example: 2384
                    type: object
                type: object
        '400':
          description: Request failed validation
          content:
            application/json:
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: The HTTP error code
                        type: integer
                        example: 400
                      message:
                        description: More detail about why the request failed validation
                        type: integer
                        example: name is required... Name of the tax
                    type: object
                type: object
        '401':
          description: Authorization information is missing or invalid
      security:
        - bearer: []
components:
  schemas:
    CalendarSubscriptionImportModel:
      title: Calendar Subscription Import Model
      description: >-
        External shared calendars that are imported into Sonderplan on a
        recurring schedule
      properties:
        id:
          description: Automatically generated, unique calendar subscription id
          type: integer
          readOnly: true
          example: 5693
        enabled:
          description: >-
            If enabled, Sonderplan will be regularly checking the external
            calendar for changes
          type: boolean
          example: true
        booking_property:
          $ref: >-
            #/components/schemas/CalendarSubscriptionImportBookingPropertiesModel
        calendar_url:
          description: >-
            URL (link) to the external calendar subscription, usually a .ics
            file
          type: string
          example: https://calendar.google.com/calendar/i
        last_checked_filesize:
          description: >-
            File size (in bytes) of the calendar subscription when we last
            checked it
          type: integer
          readOnly: true
          example: 9272
        last_checked_date:
          description: UNIX timestamp of the last time we checked the calendar feed
          type: integer
          readOnly: true
          example: 1683342643
        last_parsed_date:
          description: UNIX timestamp of the last time we parsed the calendar feed
          type: integer
          readOnly: true
          example: 1683342643
      type: object
    CalendarSubscriptionImportBookingPropertiesModel:
      title: Calendar Subscription Import Booking Properties
      description: >-
        Bookings imported from the external calendar will have these properties
        added
      properties:
        client:
          description: Booking Client
          type: array
          items:
            $ref: '#/components/schemas/CalendarSubscriptionImportClientModel'
        status:
          description: Booking Status
          type: array
          items:
            $ref: '#/components/schemas/CalendarSubscriptionImportBookingStatusModel'
        project:
          description: Booking Project
          type: array
          items:
            $ref: '#/components/schemas/CalendarSubscriptionImportProjectModel'
        resources:
          description: Booking Resources
          type: array
          items:
            $ref: '#/components/schemas/CalendarSubscriptionImportResourcesModel'
        custom_fields:
          description: Booking Custom Fields
          type: array
          items:
            type: object
            additionalProperties: true
      type: object
    CalendarSubscriptionImportClientModel:
      title: Calendar Subscription Import Client Model
      description: Client object for bookings imported from the external calendar
      properties:
        uuid:
          description: Client UUID
          type: string
          example: u2349
      type: object
    CalendarSubscriptionImportBookingStatusModel:
      title: Calendar Subscription Import Booking Status Model
      description: Status object for bookings imported from the external calendar
      properties:
        id:
          description: Status ID
          type: integer
          example: 1
      type: object
    CalendarSubscriptionImportProjectModel:
      title: Calendar Subscription Import Project Model
      description: Project object for bookings imported from the external calendar
      properties:
        id:
          description: Project ID
          type: integer
          example: 2
      type: object
    CalendarSubscriptionImportResourcesModel:
      title: Calendar Subscription Import Resources Model
      description: Resources object for bookings imported from the external calendar
      properties:
        id:
          description: Resource ID
          type: integer
          example: 1928
      type: object
  securitySchemes:
    bearer:
      type: http
      scheme: bearer

````